#! /bin/sh 
#

wsdd=/usr/sbin/wsdd
test -x "$wsdd" && WSDD_DISABLED="No" || WSDD_DISABLED="Yes"

case "$1" in
	start)
		echo ""
		echo -n "[samba] starting services"
		if [ "$WSDD_DISABLED" != "Yes" ]; then
			echo -n " wsdd"
			i="0"
			until pids=$(pidof wsdd)
			do
				echo -n "."
				let "i = i + 1"
				usleep 500000
				start-stop-daemon --start --quiet --exec $wsdd
				if [ "$i" == "10" ] ; then
					break
				fi
			done
		fi
		echo ""
		;;
	stop)
		echo -n "[samba] stopping: "
		if [ "$WSDD_DISABLED" != "Yes" ]; then
			echo -n " wsdd"
			start-stop-daemon --stop --quiet --pidfile /var/run/wsdd.pid
		fi
		echo "."
		;;
	restart)
		$0 stop;
		echo -n "[samba] stopping services"
		for i in 1 2 3 ; do
			sleep 1
			echo -n "."
		done
		echo ""
		$0 start;
		;;
	*)
		echo "Usage: /etc/init.d/wsdd {start|stop|restart}"
		exit 1
esac

exit 0

