#!/bin/sh

prefix=/usr
exec_prefix=/usr
datarootdir=${prefix}/share

if [ ! -e /etc/enigma2/dvbapp2debug.conf ] ; then
	if [ ! -d /etc/enigma2 ] ; then
		mkdir /etc/enigma2
	fi
	echo "console" > /etc/enigma2/dvbapp2debug.conf
fi

if [ -x /usr/bin/showiframe -a /usr/share/vuplus-bootlogo/backdrop.mvi ]; then
	/usr/bin/showiframe /usr/share/vuplus-bootlogo/backdrop.mvi
fi

# hook to execute scripts always before enigma2 start
if [ -x /usr/bin/enigma2_pre_start.sh ]; then
	/usr/bin/enigma2_pre_start.sh
fi

if [ -d /home/root ]; then
	cd /home/root
fi

LIBS=/usr/lib/libopen.so.0.0.0

(sleep 2; echo "enigma2 is the main pvr application... adjust oom score!"; PID=$(pidof enigma2); \
        [ -e /proc/$PID/oom_score_adj ] && echo "-999" > /proc/$PID/oom_score_adj || echo "-17" > /proc/$PID/oom_adj;) &

LD_PRELOAD=$LIBS /usr/bin/enigma2

# enigma2 exit codes:
#
# 0 - restart enigma
# 1 - halt
# 2 - reboot
#
# >128 signal

ret=$?
case $ret in
	1)
		if [ -x /usr/bin/showiframe -a /usr/share/vuplus-bootlogo/shutdown.mvi ]; then
			/usr/bin/showiframe /usr/share/vuplus-bootlogo/shutdown.mvi
		fi
		/sbin/halt
		;;
	2)
		if [ -x /usr/bin/showiframe -a /usr/share/vuplus-bootlogo/reboot.mvi ]; then
			/usr/bin/showiframe /usr/share/vuplus-bootlogo/reboot.mvi
		fi
		/sbin/reboot
		;;
	4)
		/usr/bin/software-update enigma2update
		/sbin/reboot
		;;
	*)
		;;
esac
